petsc-3.12.1 2019-10-22
Report Typos and Errors

# MatSetSizes

Sets the local and global sizes, and checks to determine compatibility

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatSetSizes(Mat A, PetscInt m, PetscInt n, PetscInt M, PetscInt N)

Collective on Mat

### Input Parameters

| A | - the matrix
| m | - number of local rows (or PETSC_DECIDE)
| n | - number of local columns (or PETSC_DECIDE)
| M | - number of global rows (or PETSC_DETERMINE)
| N | - number of global columns (or PETSC_DETERMINE)

### Notes

m (n) and M (N) cannot be both PETSC_DECIDE If one processor calls this with M (N) of PETSC_DECIDE then all processors must, otherwise the program will hang.

If PETSC_DECIDE is not used for the arguments 'm' and 'n', then the user must ensure that they are chosen to be compatible with the vectors. To do this, one first considers the matrix-vector product 'y = A x'. The 'm' that is used in the above routine must match the local size used in the vector creation routine VecCreateMPI() for 'y'. Likewise, the 'n' used must match that used as the local size in VecCreateMPI() for 'x'.

You cannot change the sizes once they have been set.

The sizes must be set before MatSetUp() or MatXXXSetPreallocation() is called.

### See Also

MatGetSize(), PetscSplitOwnership()

### Level

beginner

### Location

src/mat/utils/gcreate.c

### Examples

src/mat/examples/tutorials/ex2.c.html
src/mat/examples/tutorials/ex8.c.html
src/mat/examples/tutorials/ex15.c.html
src/mat/examples/tutorials/ex16.c.html
src/mat/examples/tutorials/ex17.c.html
src/mat/examples/tutorials/ex15f.F90.html
src/ksp/pc/examples/tutorials/ex3.c.html
src/ksp/ksp/examples/tutorials/ex1.c.html
src/ksp/ksp/examples/tutorials/ex2.c.html
src/ksp/ksp/examples/tutorials/ex3.c.html
src/ksp/ksp/examples/tutorials/ex4.c.html
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages